<?php

namespace Dedi\SyliusBannerPlugin\Repository;

use Dedi\SyliusBannerPlugin\Entity\AlertMessageInterface;
use Doctrine\ORM\EntityManagerInterface;
use Sylius\Bundle\ResourceBundle\Doctrine\ORM\EntityRepository;

class AlertMessageRepository extends EntityRepository implements AlertMessageRepositoryInterface
{
    public function __construct(EntityManagerInterface $em)
    {
        parent::__construct($em, $em->getClassMetadata(AlertMessageInterface::class));
    }

    public function getAvailableAlertMessages(\DateTimeImmutable $today): array
    {
        $qb = $this->createQueryBuilder('am');

        return $qb->where('am.enabled = 1')
            ->andWhere($qb->expr()->orX(
                $qb->expr()->isNull('am.startDateTime'),
                $qb->expr()->lte('am.startDateTime', ':today'),
            ))
            ->andWhere($qb->expr()->orX(
                $qb->expr()->isNull('am.endDateTime'),
                $qb->expr()->gte('am.endDateTime', ':today'),
            ))
            ->setParameter('today', $today)
            ->getQuery()
            ->getResult()
            ;
    }
}