<?php

namespace Dedi\SyliusBannerPlugin\Twig;

use Dedi\SyliusBannerPlugin\Repository\AlertMessageRepositoryInterface;
use Dedi\SyliusBannerPlugin\Services\ClockInterface;
use Twig\Extension\AbstractExtension;
use Twig\TwigFunction;

final class AlertMessageRetrieverExtension extends AbstractExtension implements \Twig_ExtensionInterface
{
    private ClockInterface $clock;
    private AlertMessageRepositoryInterface $alertMessageRepository;

    public function __construct(
        ClockInterface $clock,
        AlertMessageRepositoryInterface $alertMessageRepository
    ) {
        $this->clock = $clock;
        $this->alertMessageRepository = $alertMessageRepository;
    }

    public function getFunctions(): array
    {
        return [
            new TwigFunction(
                'app_retrieve_available_alert_messages',
                fn (): array => $this->alertMessageRepository->getAvailableAlertMessages($this->clock->getDateTimeImmutable())
            ),
        ];
    }
}